package com.bigdata.wxappserver.controller;

import com.bigdata.wxappserver.result.Result;
import com.github.binarywang.wxpay.bean.request.WxPayUnifiedOrderV3Request;
import com.github.binarywang.wxpay.bean.result.WxPayOrderQueryResult;
import com.github.binarywang.wxpay.bean.result.enums.TradeTypeEnum;
import com.github.binarywang.wxpay.service.WxPayService;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.UUID;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/03/22:25
 * @Description:
 */
@RestController
@Slf4j
public class TestController {
    @Autowired
    private WxPayService wxService;


    @PostMapping("/unifiedOrder")
    public Result unifiedOrder() throws Exception {
        String orderCode = UUID.randomUUID().toString().replace("-", "");
        WxPayUnifiedOrderV3Request wxPayUnifiedOrderRequest = new WxPayUnifiedOrderV3Request();

        wxPayUnifiedOrderRequest.setDescription("商品描述");
        wxPayUnifiedOrderRequest.setOutTradeNo(orderCode);
        wxPayUnifiedOrderRequest.setNotifyUrl("https://49.233.248.140:8082/order/loadData");

        WxPayUnifiedOrderV3Request.Amount amount = new WxPayUnifiedOrderV3Request.Amount();
        amount.setTotal(100); // 订单总金额，单位为分
        wxPayUnifiedOrderRequest.setAmount(amount);
        WxPayUnifiedOrderV3Request.Payer payer = new WxPayUnifiedOrderV3Request.Payer();
        payer.setOpenid(UUID.randomUUID().toString().replace("-", "")); // 需要获取用户的OpenID
        wxPayUnifiedOrderRequest.setPayer(payer);
        wxService.createOrderV3(TradeTypeEnum.JSAPI, wxPayUnifiedOrderRequest);
        return Result.success();
    }

    @PostMapping("/queryOrder")
    public Result queryOrder(String outTradeNo) throws Exception {
        WxPayOrderQueryResult wxPayOrderQueryResult = wxService.queryOrder(null, outTradeNo);
        log.info(wxPayOrderQueryResult.toString());
        return Result.success(wxPayOrderQueryResult);
    }


}
